Compare commits

..
2 Commits
Author SHA1 Message Date
hanyixuanten 1b451ba0e4 new file: solutions/CF1187E.md
Check cpp / md pair / Check md headers (push) Successful in 5s
2026-10-27 07:50:14 +00:00
hanyixuanten 199d501394 new file: CF1187E.cpp 2026-10-27 07:32:45 +00:00
3 changed files with 147 additions and 0 deletions

No files matched your search

+45
View File
@@ -0,0 +1,45 @@
#include<bits/stdc++.h>
#define int long long
using namespace std;
int n;
vector<int> fri[200005];
int siz[200005];
int f[200005];
int ans[200005];
void dfs(int now, int from) {
siz[now] = 1;
f[now] = 0;
for(int i:fri[now]) {
if(i == from) continue;
dfs(i, now);
f[now] += f[i];
siz[now] += siz[i];
}
f[now] += siz[now];
}
void pass(int now, int from) {
for(int i:fri[now]) {
if(i == from) continue;
ans[i] = ans[now] + n - siz[i] * 2;
pass(i, now);
}
}
signed main() {
scanf("%lld", &n);
for(int i = 1, u, v; i < n; ++i) {
scanf("%lld%lld", &u, &v);
fri[u].push_back(v);
fri[v].push_back(u);
}
dfs(1, -1);
ans[1] = f[1];
pass(1, -1);
int res = ans[1];
for(int i = 1; i <= n; ++i) res = max(res, ans[i]);
printf("%lld\n", res);
return 0;
}
/*
dp[i] 表示 i 子树中将 i 先染色的最大贡献
g u=g father u+n−siz u×2
*/
+79
View File
@@ -0,0 +1,79 @@
# CF1187E Tree Painting
## 题目描述
给定一棵包含 $n$ 个顶点的树(无向连通无环图)。你要在这棵树上玩一个游戏。
最开始所有顶点都是白色的。在游戏的第一回合,你选择一个顶点并将其染成黑色。之后的每一回合,你都可以选择一个与任意黑色顶点相邻的白色顶点,并将其染成黑色。
每当你选择一个顶点(包括第一回合),你获得的分数等于**染色前**包含该顶点的、仅由白色顶点组成的连通块的大小。游戏在所有顶点都被染成黑色时结束。
来看下面这个例子:
![](https://cdn.luogu.com.cn/upload/vjudge_pic/CF1187E/80d1bdfd9c05e38560143dd180baa827e846ec90.png)
顶点 $1$ 和 $4$ 已经被染成黑色。如果你选择顶点 $2$,你将获得 $4$ 分,因为包含顶点 $2, 3, 5, 6$ 的连通块的大小为 $4$。如果你选择顶点 $9$,你将获得 $3$ 分,因为包含顶点 $7, 8, 9$ 的连通块的大小为 $3$。
你的任务是最大化你获得的分数。
## 输入格式
第一行包含一个整数 $n$,表示树的顶点数($2 \le n \le 2 \times 10^5$)。
接下来的 $n-1$ 行,每行描述树的一条边。第 $i$ 条边由两个整数 $u_i$ 和 $v_i$ 表示,表示该边连接顶点 $u_i$ 和 $v_i$($1 \le u_i, v_i \le n$,$u_i \ne v_i$)。
保证给定的边构成一棵树。
## 输出格式
输出一个整数,表示如果你采取最优策略,最多可以获得多少分。
## 输入输出样例 #1
### 输入 #1
```
9
1 2
2 3
2 5
2 6
1 4
4 9
9 7
9 8
```
### 输出 #1
```
36
```
## 输入输出样例 #2
### 输入 #2
```
5
1 2
1 3
2 4
2 5
```
### 输出 #2
```
14
```
## 说明/提示
第一个示例的树如题目描述中的图片所示。
由 ChatGPT 4.1 翻译
+23
View File
@@ -0,0 +1,23 @@
# CF1187E Tree Painting 题解
题意:树上 $01$ 染色,一个点染上色获得的分数等于这个点原本所在的连通块的大小。
考虑树形 dp,则 $dp_{fa} = size_{fa} + \sum_{u \in child_{fa}} dp_u$
,其中 $size_{fa}$ 表示以 $fa$ 为根的子树的大小。
注意到总答案和根的选择有关系,朴素做法是直接运行 $n$ 次树形 dp,复杂度为 $O(n^2)$,无法通过。
考虑使用换根 dp,考虑确定以 $fa$ 为根时的答案,如何转移到以 $u (u \in child_{fa})$ 为根的答案。
$$
\begin{aligned}
\because ans_{root} =& size_{root} + \sum_{u \in child_{root}} dp_u \\
\therefore ans_{u} =& (f_u - size_u) + (ans_{root} - f_u - size_u) + n \\
&(u\text{的孩子的贡献}) (root\text{其他孩子的贡献}) \\
=& ans_u - 2\times size_u + n
\end{aligned}
$$
因此,只需要以 $1$ 为根节点计算一次,随后进行答案转移即可。
[CF1187E.cpp](../CF1187E.cpp)